Attribute VB_Name = "OGL1"
Option Explicit
Private hRC As Long   'GL window handle
Private gHDC As Long  'Win window handle
Global Texture(100) As Long

Global angleX As Single



Function WindowCreate(HDC As Long, DoubleBuffer As Boolean) As Long
gHDC = HDC

Dim pfd As PIXELFORMATDESCRIPTOR
Dim pixformat As Long
    
    ZeroMemory pfd, Len(pfd)
    pfd.nSize = Len(pfd)
    pfd.nVersion = 1
    
    pfd.dwFlags = PFD_DRAW_TO_WINDOW Or PFD_SUPPORT_OPENGL
    If DoubleBuffer Then pfd.dwFlags = PFD_DRAW_TO_WINDOW Or PFD_SUPPORT_OPENGL Or PFD_DOUBLEBUFFER
    
    pfd.iPixelType = PFD_TYPE_RGBA
    pfd.cColorBits = 24
    pfd.cDepthBits = 32
    pfd.iLayerType = PFD_MAIN_PLANE
    
    pixformat = ChoosePixelFormat(gHDC, pfd)
    If pixformat = 0 Then GoTo ee
    SetPixelFormat gHDC, pixformat, pfd
    hRC = wglCreateContext(gHDC)
WindowCreate = hRC

wglMakeCurrent gHDC, hRC

Exit Function
ee: MsgBox "OpenGL window not created!"
WindowCreate = 0
    End
End Function

Sub WindowKill()
    wglMakeCurrent 0, 0
    wglDeleteContext hRC
End Sub

Sub WindowResize(Width As Long, Height As Long)
'wglMakeCurrent gHDC, hRC
        
    If Height = 0 Then Height = 1
    glViewport 0, 0, Width, Height
                 
End Sub

Sub SetProjection(Fovy As Double, Width As Long, Height As Long, zNear As Double, zFar As Double)
'wglMakeCurrent gHDC, hRC

    Dim aspectratio As Double
    glMatrixMode mmProjection
    glLoadIdentity
    'aspect s lttvolsg
    If Height = 0 Then Height = 1
    aspectratio = Width / Height
    gluPerspective Fovy, aspectratio, zNear, zFar           'gLookFarMax  ' 108km
    glMatrixMode mmModelView
    glLoadIdentity
End Sub
Sub SetFogColor(R As Single, G As Single, B As Single)

Dim FogsColor!(0 To 3)
Dim density As Single
    FogsColor(0) = R
    FogsColor(1) = G
    FogsColor(2) = B
    FogsColor(3) = 1
    glFogfv GL_FOG_COLOR, FogsColor(0)
 
End Sub


Sub SetFog(fStart As Single, fEnd As Single)
'fog
Dim density As Single
    density = 0.3
   glEnable GL_FOG
    
    glFogi GL_FOG_MODE, GL_LINEAR ' GL_EXP2 ' GL_LINEAR 'GL_EXP 'GL_LINEAR
      '  glFogi GL_FOG_MODE, GL_EXP:     glFogf GL_FOG_DENSITY, density
    
    glFogf fogStart, fStart  ' fog!!!!!!!!!!!!!!!!
    glFogf fogEnd, fEnd
    
    glHint GL_FOG_HINT, GL_NICEST ' hmFastest 'GL_NICEST
End Sub

Sub SetLighting()
'wglMakeCurrent gHDC, hRC
    glShadeModel smSmooth 'smSmooth ' smFlat 'smSmooth
    glEnable GL_LIGHTING  'enable lighting
    glEnable glcLight0   'enable light0
 
Dim DiffuseMaterial!(0 To 3) 'this will hold our red diffuse material variables
Dim SpecularMaterial!(0 To 3) 'this will hold our white specular material variables
Dim EmissiveMaterial!(0 To 3) 'this will hold our green emissive material variables
Dim SpecularLight!(0 To 3) 'this will hold our white specular light variables
Dim AmbientLight!(0 To 3) 'this will hold our black ambient light variables
Dim DiffuseLight!(0 To 3) 'this will hold our white diffuse light variables
Dim Lightposition!(0 To 3)
         
    'set up our  diffuse material
    DiffuseMaterial(0) = 0
    DiffuseMaterial(1) = 0
    DiffuseMaterial(2) = 0
    DiffuseMaterial(3) = 1
    glMaterialfv faceFrontAndBack, mprDiffuse, DiffuseMaterial(0)

    SpecularMaterial(0) = 0
    SpecularMaterial(1) = 0
    SpecularMaterial(2) = 0
    SpecularMaterial(3) = 1
    glMaterialfv faceFrontAndBack, mprSpecular, SpecularMaterial(0)
    glMaterialfv faceFrontAndBack, mprShininess, 128 ' 0-128 a max
    
 
    EmissiveMaterial(0) = Form1.HScroll10 / 1000
    EmissiveMaterial(1) = Form1.HScroll10 / 2000
    EmissiveMaterial(2) = Form1.HScroll10 / 2000
    EmissiveMaterial(3) = 1
    glMaterialfv faceFrontAndBack, mprEmission, EmissiveMaterial(0)
   
    
    DiffuseLight(0) = Form1.HScroll7 / 1000
    DiffuseLight(1) = Form1.HScroll7 / 1000
    DiffuseLight(2) = Form1.HScroll7 / 1000
    DiffuseLight(3) = 1
    glLightfv ltLight0, lpmDiffuse, DiffuseLight(0)
        
     
    AmbientLight(0) = Form1.HScroll8 / 1000
    AmbientLight(1) = Form1.HScroll8 / 1000
    AmbientLight(2) = Form1.HScroll8 / 1000
    AmbientLight(3) = 1
    glLightfv ltLight0, lpmAmbient, AmbientLight(0)
    
      
    SpecularLight(0) = Form1.HScroll9 / 1000
    SpecularLight(1) = Form1.HScroll9 / 1000
    SpecularLight(2) = Form1.HScroll9 / 1000
    SpecularLight(3) = 1
    glLightfv ltLight0, lpmSpecular, SpecularLight(0)
     
 
   
   glEnable glcColorMaterial
       'attach our white specular light to light0
    'glLightfv ltLight0, lpmAmbient, AmbientLight(0)  'attach our black ambient light to light0
    '   'attach our white diffuse light to light0
         
    ''glMaterialfv faceFrontAndBack, mprEmission, EmissiveMaterial(0)
    '
  
   

End Sub

Sub Draw()
'new screen
 glClearColor 0, 0, 0, 0
 glClear GL_COLOR_BUFFER_BIT Or GL_DEPTH_BUFFER_BIT Or GL_STENCIL_BUFFER_BIT '++++
    glEnable GL_STENCIL_TEST
    glStencilOp GL_KEEP, GL_KEEP, GL_REPLACE

 
 glLoadIdentity
 

 
'global rotate
glRotatef Motor.OBJMAN(0).AngX, 1, 0, 0
glRotatef Motor.OBJMAN(0).AngY, 0, 1, 0
glRotatef Motor.OBJMAN(0).AngZ, 0, 0, 1

'sun rotate
Dim Lightposition!(0 To 3)
    Lightposition(0) = Form1.HScroll1 - 15000
    Lightposition(1) = Form1.HScroll2 + 200
    Lightposition(2) = Form1.HScroll3 - 15000
    Lightposition(3) = 1
    glLightfv ltLight0, GL_POSITION, Lightposition(0)

Form1.Text16 = Arcsin(Lightposition(0) / Lightposition(2))

'global translate
glTranslatef Motor.OBJMAN(0).PosX, Motor.OBJMAN(0).PosY, Motor.OBJMAN(0).PosZ

SetLighting
SetFog Form1.HScroll5, Form1.HScroll5 + 200

'draw scene**********************************
'draw sky
glPushAttrib amAllAttribBits
 glCallList 3 'Sky
 GL.glCallList 13 'sun
glPopAttrib

'glPushAttrib amAllAttribBits
glPushMatrix
glTranslatef 0, 340, 100
glBindTexture glTexture2D, Texture(3)
glutSolidCube 80
glPopMatrix
'glPopAttrib

'*****draw land
If Form1.Check1.value = 1 Then
glPopAttrib
glPushAttrib amAllAttribBits
glCallList 1 ' Terrain
End If

If Form1.Check8.value = 1 Then
glPopAttrib
glPushAttrib amAllAttribBits
GL.glCallList 2 'multitexture
End If

'*****draw objects
glPopAttrib
glPushAttrib amAllAttribBits
GL.glCallList 15 'fa
glPopAttrib

glPushAttrib amAllAttribBits
GL.glCallList 20 'fal
glPopAttrib



'fire
glPushAttrib amAllAttribBits
Static an As Integer
Dim speed As Single
speed = 10
If an = 14 * speed Then an = 0
glBindTexture glTexture2D, Texture(an \ speed + 20)
an = an + 1
GL.glCallList 21 'fire
'fireanim
glPopAttrib


'dust
glPushAttrib amAllAttribBits
glPushMatrix
Static an2 As Integer
Dim speed2 As Single
speed2 = 10
If an2 = 14 * speed Then an2 = 0


glColor4f 0.5, 0.5, 0.5, 0.05
'glRotatef an2, 0, 1, 0
glTranslatef an2 / 5, an2 / 2, 0
GL.glCallList 22 'dust
glTranslatef an2 / 5, an2, 0
GL.glCallList 22 'dust
'fireanim
glPopMatrix
glPopAttrib

an2 = an2 + 1

'*****draw objects
glPopAttrib
glPushAttrib amAllAttribBits
Terrain.masked2 ' 15 'maskedit
glPopAttrib



'*****last drawing the glass objects!!!
glPushAttrib amAllAttribBits
GL.glCallList 11 'uvegfal
glPopAttrib


SwapBuffers gHDC
 
 End Sub

'bmp textura betolto
Function TextureLoad(number As Integer, Filename As String, Optional mipped As Integer)
'wglMakeCurrent gHDC, hRC

If Dir(Filename) = "" Then MsgBox "Missing Texture: " & Filename, , "Texture Load Error": Exit Function


Dim sFile As String
Dim bmFile As BITMAPFILEHEADER
Dim bmInfo As BITMAPINFOHEADER
Dim bmRGB() As RGBQUAD
Dim iFile As Integer
Dim lImageSize As Long
Dim iPixelSize As Integer
Dim baImageData() As Byte

  sFile = App.Path & "\" & Filename
  
  iFile = FreeFile
  
  Open sFile For Binary As iFile
  
  Get #iFile, , bmFile
  Get #iFile, , bmInfo
  
  If (bmInfo.biBitCount < 24) Then
    ReDim bmRGB(bmInfo.biClrUsed)
    Get #iFile, , bmRGB
  End If
  
  iPixelSize = bmInfo.biBitCount / 8
  lImageSize = bmInfo.biWidth * bmInfo.biHeight * iPixelSize
  
  ReDim baImageData(lImageSize)
  Get #iFile, , baImageData
  Close #iFile
    
  glGenTextures 1, Texture(number)
  glBindTexture glTexture2D, Texture(number)
  
  'GoTo mipmap
 ' Dim mipped
'mipped = 0

If mipped = 1 Then GoTo mipmap
  
  'nomipmap
  glTexParameteri glTexture2D, tpnTextureMagFilter, GL_LINEAR
  glTexParameteri glTexture2D, tpnTextureMinFilter, GL_LINEAR
  glTexImage2D glTexture2D, 0, 3, bmInfo.biWidth, bmInfo.biHeight, 0, tiBGRExt, GL_UNSIGNED_BYTE, baImageData(0)
  
  GoTo uu
mipmap:
  glTexParameteri glTexture2D, tpnTextureMagFilter, GL_LINEAR
  'glTexParameteri glTexture2D, tpnTextureMinFilter, GL_LINEAR
  
  glTexParameteri glTexture2D, tpnTextureMinFilter, GL_LINEAR_MIPMAP_NEAREST
  glTexImage2D glTexture2D, 0, 3, bmInfo.biWidth, bmInfo.biHeight, 0, tiBGRExt, GL_UNSIGNED_BYTE, baImageData(0)
  gluBuild2DMipmaps glTexture2D, 3, bmInfo.biWidth, bmInfo.biHeight, tiBGRExt, GL_UNSIGNED_BYTE, VarPtr(baImageData(0))
 
 
 'glTexParameterf GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT
 'glTexParameterf GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT

uu:
End Function

'picturebox textura betolto
Public Sub TexturePicLoad(number As Integer, pic As PictureBox, Optional mipped As Integer)

'this sub loads a texture out of a picturebox into the texture memory
Dim bmpHeight As GLfloat, bmpWidth As GLfloat
Dim i As Long, j As Long, k As Long

'first we are going to load all picture-data into an array
bmpHeight = pic.ScaleHeight                     'setting width and height
bmpWidth = pic.ScaleWidth

'an array with 1 dimension loads quicker than one with 3 dimensions.
'you might want to change to 3 dimensions for simplicity
ReDim bmpimage(bmpHeight * bmpWidth * 3 - 1)   'right array size

'no picture-boundry test is needed here, so we can begin loading our texture
Dim x As Long                               'retrieving rgb-values from picturebox
x = 0
For i = 0 To bmpWidth - 1
    For j = 0 To bmpHeight - 1
        k = pic.Point(i, j)                 'extracting rgb - value out of picbox
        
        bmpimage(x) = (k And &HFF&)
        bmpimage(x + 1) = ((k And &HFF00&) / &H100&)
        bmpimage(x + 2) = ((k And &HFF0000) / &H10000)
        x = x + 3
    Next j
Next i

'storing texture and binding it
glGenTextures 1, Texture(number)                 'generating a texture
glBindTexture glTexture2D, Texture(number)      'select current texture

'''''glPixelStorei pxsUnpackAlignment, 1
'select modulate to mix texture with color for shading
glTexEnvf tetTextureEnv, tenTextureEnvMode, tepModulate

'when texture is large, bilinear filter the first mipmap
glTexParameterf GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR
glTexParameterf GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR
    
'when wrapping is enabled, send gl_repeat to texture-wrapping
'in this application gl_clamp doesn't work, so don't change following 2 lines
glTexParameterf glTexture2D, tpnTextureWrapS, GL_REPEAT
glTexParameterf glTexture2D, tpnTextureWrapT, GL_REPEAT

'creating a texture
glTexImage2D glTexture2D, 0, 3, bmpWidth, bmpHeight, 0, GL_RGB, GL_UNSIGNED_BYTE, bmpimage(0)

Erase bmpimage                          'cleaning up the mess

End Sub


'alpha textura betolto
Function TextureAlphaLoad(number As Integer, Filename As String, Optional mipped As Integer)
'wglMakeCurrent gHDC, hRC

Dim sFile As String
Dim bmFile As BITMAPFILEHEADER
Dim bmInfo As BITMAPINFOHEADER
Dim bmRGB() As RGBQUAD
Dim iFile As Integer
Dim lImageSize As Long
Dim iPixelSize As Integer
Dim baImageData() As Byte
Dim AlphaData() As Byte

  sFile = App.Path & "\" & Filename
  
  iFile = FreeFile
  
  Open sFile For Binary As iFile
  
  Get #iFile, , bmFile
  Get #iFile, , bmInfo
  
  If (bmInfo.biBitCount < 24) Then
    ReDim bmRGB(bmInfo.biClrUsed)
    Get #iFile, , bmRGB
  End If
  
  iPixelSize = bmInfo.biBitCount / 8
  lImageSize = bmInfo.biWidth * bmInfo.biHeight * iPixelSize
  
  ReDim baImageData(lImageSize)
  Get #iFile, , baImageData
  Close #iFile
  
  'alpha**********************************************************************
  
  sFile = App.Path & "\" & Filename
  
  sFile = Mid(sFile, 1, Len(sFile) - 4) & "a.bmp"
  
  iFile = FreeFile
  
  Open sFile For Binary As iFile
  
  Get #iFile, , bmFile
  Get #iFile, , bmInfo
  
  If (bmInfo.biBitCount < 24) Then
    ReDim bmRGB(bmInfo.biClrUsed)
    Get #iFile, , bmRGB
  End If
  
  iPixelSize = bmInfo.biBitCount / 8
  lImageSize = bmInfo.biWidth * bmInfo.biHeight * iPixelSize
  
  ReDim AlphaData(lImageSize)
  Get #iFile, , AlphaData
  Close #iFile
  
  glGenTextures 1, Texture(number)
  glBindTexture glTexture2D, Texture(number)
  
  
 Dim enddata() As Byte
 ReDim enddata(lImageSize / 3 * 4)
 Dim ww As Long
 
 Dim w As Long
 For w = 0 To lImageSize / 3 * 4 - 20 Step 4
 enddata(w) = baImageData(ww + 2)
 enddata(w + 1) = baImageData(ww + 1)
 enddata(w + 2) = baImageData(ww + 0)
 enddata(w + 3) = 255 - AlphaData(ww)
'  baImageData(w) = 128
 
ww = ww + 3
 Next w
 
  GoTo mipmap
 
 'nomipmap
  glTexParameteri glTexture2D, tpnTextureMagFilter, GL_LINEAR
  glTexParameteri glTexture2D, tpnTextureMinFilter, GL_LINEAR
 glTexImage2D glTexture2D, 0, GL_RGBA, bmInfo.biWidth, bmInfo.biHeight, 0, GL_RGBA, GL_UNSIGNED_BYTE, enddata(0)

'mipmap
mipmap:
  glTexParameteri glTexture2D, tpnTextureMagFilter, GL_LINEAR
  'glTexParameteri glTexture2D, tpnTextureMinFilter, GL_LINEAR
  
  glTexParameteri glTexture2D, tpnTextureMinFilter, GL_LINEAR_MIPMAP_NEAREST
  glTexImage2D glTexture2D, 0, GL_RGBA, bmInfo.biWidth, bmInfo.biHeight, 0, GL_RGBA, GL_UNSIGNED_BYTE, enddata(0)
  gluBuild2DMipmaps glTexture2D, GL_RGBA, bmInfo.biWidth, bmInfo.biHeight, GL_RGBA, GL_UNSIGNED_BYTE, VarPtr(enddata(0))

End Function

'alpha textura betolto
Function TextureAlphaBlendLoad(number As Integer, Filename As String, Optional mipped As Integer)
'wglMakeCurrent gHDC, hRC

Dim sFile As String
Dim bmFile As BITMAPFILEHEADER
Dim bmInfo As BITMAPINFOHEADER
Dim bmRGB() As RGBQUAD
Dim iFile As Integer
Dim lImageSize As Long
Dim iPixelSize As Integer
Dim baImageData() As Byte
Dim AlphaData() As Byte

  sFile = App.Path & "\" & Filename
  
  iFile = FreeFile
  
  Open sFile For Binary As iFile
  
  Get #iFile, , bmFile
  Get #iFile, , bmInfo
  
  If (bmInfo.biBitCount < 24) Then
    ReDim bmRGB(bmInfo.biClrUsed)
    Get #iFile, , bmRGB
  End If
  
  iPixelSize = bmInfo.biBitCount / 8
  lImageSize = bmInfo.biWidth * bmInfo.biHeight * iPixelSize
  
  ReDim baImageData(lImageSize)
  Get #iFile, , baImageData
  Close #iFile
  
  'alpha**********************************************************************
  
  sFile = App.Path & "\" & Filename
  
  sFile = Mid(sFile, 1, Len(sFile) - 4) & "a.bmp"
  
  iFile = FreeFile
  
  Open sFile For Binary As iFile
  
  Get #iFile, , bmFile
  Get #iFile, , bmInfo
  
  If (bmInfo.biBitCount < 24) Then
    ReDim bmRGB(bmInfo.biClrUsed)
    Get #iFile, , bmRGB
  End If
  
  iPixelSize = bmInfo.biBitCount / 8
  lImageSize = bmInfo.biWidth * bmInfo.biHeight * iPixelSize
  
  ReDim AlphaData(lImageSize)
  Get #iFile, , AlphaData
  Close #iFile
  
  glGenTextures 1, Texture(number)
  glBindTexture glTexture2D, Texture(number)
  
  
 Dim enddata() As Byte
 ReDim enddata(lImageSize / 3 * 4)
 Dim ww As Long
 
 Dim w As Long
 For w = 0 To lImageSize / 3 * 4 - 20 Step 4
 enddata(w) = baImageData(ww + 2)
 enddata(w + 1) = baImageData(ww + 1)
 enddata(w + 2) = baImageData(ww + 0)
 enddata(w + 3) = 255 - AlphaData(ww)
'  baImageData(w) = 128
 
ww = ww + 3
 Next w
 
  GoTo mipmap
 
 'nomipmap
  glTexParameteri glTexture2D, tpnTextureMagFilter, GL_LINEAR
  glTexParameteri glTexture2D, tpnTextureMinFilter, GL_LINEAR
 glTexImage2D glTexture2D, 0, GL_RGBA, bmInfo.biWidth, bmInfo.biHeight, 0, GL_RGBA, GL_UNSIGNED_BYTE, enddata(0)

'mipmap
mipmap:
  glTexParameteri glTexture2D, tpnTextureMagFilter, GL_LINEAR
  'glTexParameteri glTexture2D, tpnTextureMinFilter, GL_LINEAR
  
  glTexParameteri glTexture2D, tpnTextureMinFilter, GL_LINEAR_MIPMAP_NEAREST
  glTexImage2D glTexture2D, 0, GL_RGBA, bmInfo.biWidth, bmInfo.biHeight, 0, GL_RGBA, GL_UNSIGNED_BYTE, enddata(0)
  gluBuild2DMipmaps glTexture2D, GL_RGBA, bmInfo.biWidth, bmInfo.biHeight, GL_RGBA, GL_UNSIGNED_BYTE, VarPtr(enddata(0))

End Function

'picturebox textura betolto
Sub texturePicLoad2(number As Integer, pic As PictureBox, Optional mipped As Integer)
    ' The file should be BMP with pictures 64x64,128x128,256x256 .....
    Dim x As Long, y As Long, temp As Long
    Dim w As Long, h As Long
    Dim TextureImg() As GLbyte
    Dim bi24BitInfo As BITMAPINFO
    
    'If Dir( Filename) = "" Then End
    
    'Loading Picture into PictureBox
    With pic
        '''''''''''''''''''';;;.Picture = LoadPicture(Filename)
        'with small modifications images can be obtained from resource too
        '.Picture = LoadResPicture(number) and parameter FileName can be removed
        .Refresh
        w = .ScaleWidth
        h = .ScaleHeight
        ' Create the array as needed for the image.
        ReDim TextureImg(2, w - 1, h - 1)
    End With
    
    'Getting data from PictureBox directly
    With bi24BitInfo.bmiHeader
        .biBitCount = 24
        .biCompression = 0 ' BI_RGB
        .biPlanes = 1
        .biSize = Len(bi24BitInfo.bmiHeader)
        .biWidth = w
        .biHeight = h
    End With
   '''' GetDIBits Stage.Pict.HDC, Stage.Pict.Image, 0, H, TextureImg(0, 0, 0), bi24BitInfo, 0
    
    'Swap BGR->RGB
    For x = 0 To w - 1
        For y = 0 To h - 1
        temp = TextureImg(0, x, y)
        TextureImg(0, x, y) = TextureImg(2, x, y)
        TextureImg(2, x, y) = temp
        Next y
    Next x
    
    glGenTextures 1, Texture(number) '+
    glBindTexture glTexture2D, Texture(number) '+
    
    
    glPixelStorei GL_UNPACK_ALIGNMENT, 1
    glTexImage2D GL_TEXTURE_2D, 0, 3, w, h, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImg(0, 0, 0)
    
    Erase TextureImg

End Sub

Sub OGLDefault()
glEnable glcTexture2D
glDisable glcAlphaTest
glDisable glcBlend
glEnable glcDepthTest
glEnable glcColorMaterial
glDisable glcCullFace
glEnable glcDepthTest
glEnable glcFog
glEnable glcLighting
glEnable glcLight0

GL.glShadeModel smSmooth
glPolygonMode faceFrontAndBack, pgmFILL
glDepthFunc cfLess
'glColor4f 0.1, 0.1, 0.1, 1

End Sub
